-- July 2011 Insider demo
-- Database snapshots memory usage

-- Get SalesDB from http://www.sqlskills.com/PastConferences.asp
RESTORE DATABASE SalesDB
	FROM DISK = N'D:\SQLskills\DemoBackups\SalesDBOriginal.bak'
WITH STATS = 10, REPLACE;
GO

-- Create the snapshot
CREATE DATABASE SalesDB_Snapshot
ON (
	NAME = N'SalesDBData',
	FILENAME = N'C:\SQLskills\test\SalesDBData.mdfss')
AS SNAPSHOT OF SalesDB;
GO

-- How big is it on disk?

-- Now do some selects

USE SalesDB;
GO

SELECT COUNT (*) FROM Sales;
GO

USE SalesDB_Snapshot;
GO

SELECT COUNT (*) FROM Sales;
GO

-- Now check snapshot size again

-- What about in the buffer pool, using other script?

-- Let's look deeper...

-- Get this from http://tinyurl.com/3rykz84
EXEC sp_AllocationMetadata 'Sales';
GO

-- And then let's look at a page in both
-- databases
DBCC TRACEON (3604);
GO

DBCC PAGE (SalesDB, 1, XX, 3);
GO

DBCC PAGE (SalesDB_Snapshot, 1, XX, 3);
GO
